import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.XMLReader;
import org.xml.sax.SAXParseException;
import org.xml.sax.helpers.XMLReaderFactory;

class MyHandler extends DefaultHandler {
    public void startElement(String uri,   String localName,
                             String qName, Attributes attributes)  
                             throws SAXException {

    }
    public void warning(SAXParseException e) throws SAXException {
    }
    public void error(SAXParseException e) throws SAXException {
      System.out.println(getMessage("Error",e).replaceAll("\"http://www.mcs.anl.gov/neos\"","neos"));
      System.exit(1);
    }
    public void fatalError(SAXParseException e) throws SAXException 
    {
        throw new SAXException(getMessage("Fatal Error", e));
    }
    private String getMessage(String level, SAXParseException e) {
        return ( "Parsing " + level + "\n" +
                 "Line:    " + e.getLineNumber() + "\n" +
                 "Message: " + e.getMessage()             );
    }
}

public class XMLValidator {
    public static void main(String[] args) {
	if (args.length != 2) {
	    System.out.println("Usage: java XMLValidator <solver.xml> <xsdfile>");
	    System.exit(1);
	}
        try{
            XMLReader reader = XMLReaderFactory.createXMLReader("org.apache.xerces.parsers.SAXParser");
	    reader.setFeature("http://xml.org/sax/features/validation", true);
	    reader.setFeature("http://apache.org/xml/features/validation/schema", true);
            reader.setProperty("http://apache.org/xml/properties/schema/external-schemaLocation", "http://www.mcs.anl.gov/neos " + args[1]);

            MyHandler handler = new MyHandler();
            
            reader.setContentHandler(handler);
            reader.setErrorHandler(handler);
            reader.parse(args[0]);
	    System.exit(0);
        }
        catch (Exception e) {
            e.printStackTrace();
	    System.exit(1);
        }
    }
}


