#!/usr/bin/env python
import os
import socket
import re
import uu
import sys

executables = {}
host = socket.gethostbyaddr(socket.gethostname())[0]
if re.search(r'mcs\.anl\.gov',host):
  sys.path.append('/homes/neosotc/neos-5')
  os.environ['LOQODIR'] = '/homes/neosotc'
  executables['loqo'] = '/home/more/neos/loqo/neos/lib/linux/loqo'
  
#else if re.search(r'iems\.[(nwu)|(northwestern)]\.edu',host):


import SolverTools.SolverBase
from config import Variables

#kestrel files include
#  uu-encoded kestreluu.nl file,
#  kestrel.aux,
#  mip_priorities
#  solver_options (lines of key:value)



#uu-decode the nl file
uufile = open('kestreluu.nl','r')
nlfile = open('kestrel.nl','wb')
uu.decode(uufile,nlfile)
uufile.close()
nlfile.close()

#read the options file, put in dict and environment
options = {}
optionsfile = open('solver_options','r')
for line in optionsfile.readlines():
  m = re.match(r'(\S+):(\S*)',line)
  if m and len(m.groups()):
    options[m.groups()[0]] = m.groups()[1]
    os.environ[m.groups()[0]] = m.groups()[1]
optionsfile.close()
if 'kestrel_options' in options.keys():
  opt= options['kestrel_options']
  m = re.match(r'solver=(\S+)',opt)
  if m and len(m.groups()):
    solver_name = m.groups()[0]
  else:
    print "Error: $kestrel_options='%s' is not valid." % opt
    sys.exit(1)
else:
  print "Error: $kestrel_options not set."
  sys.exit(1)
  

print "Executing algorithm...\n"
solver = SolverTools.SolverBase.SolverBase()
status = solver.execute(executables[solver_name], options="kestrel.nl -AMPL")
if status:
  print "Error: solver exited with code %d" % status
  sys.exit(1)

#uu-encode solution file if it exists
if os.access("kestrel.sol",os.R_OK):
  kestrel_sol = open("kestrel.sol","rb")
  jobresults = open("job.results","w")
  uu.encode(kestrel_sol,jobresults)
  











  

  
