#!/usr/bin/env python
import sys
import os
import xmlrpclib
import re

from config import Variables

if len(sys.argv) != 3:
  sys.stderr.write("Usage: remove cat:solver:input password\n")
  sys.exit(1)

neos = xmlrpclib.Server("http://%s:%d" % (Variables.NEOS_HOST, Variables.NEOS_PORT))

solver = sys.argv[1]
password = sys.argv[2]

m = re.match(r'(\S+):(\S+):(\S+)',solver)
if m and m.groups():
  (cat,s,input) = m.groups()
else:
  sys.stderr.write("Usage: remove cat:solver:input password\n")
  sys.exit(1)
    
response = neos.removeSolver(cat,s,input,password)
sys.stdout.write(response)

